#include <dshow.h>
#include <iostream>
#include <qedit.h>

#include "MySampleGrabberCB.h"

//@#pragma comment(lib,"strmiids.lib")
//@#pragma comment(lib,"strmbase.lib")
//@#pragma comment(lib,"winmm.lib")

int					m_iCameraNumber=1;
int					m_Width;
int					m_Height;
int					m_Size;
IBaseFilter			*pF = NULL;
BYTE				*m_CamImage;
CMySampleGrabberCB  *m_MySampleGrabberCB;
ISampleGrabber		*pSGrab;
ICaptureGraphBuilder2 *pBuilder = NULL;
BYTE				*m_RingBufImage;
IBaseFilter			*pSrc = NULL;
IMediaControl		*pMediaControl = NULL;
IGraphBuilder		*pGraph = NULL;

void TRACE(...) { }

IPin *GetPin(IBaseFilter *pFilter, PIN_DIRECTION PinDir)
{
  BOOL       bFound = FALSE;
  IEnumPins  *pEnum;
  IPin       *pPin;
  pFilter->EnumPins(&pEnum);
  while(pEnum->Next(1, &pPin, 0) == S_OK)
    {
      PIN_DIRECTION PinDirThis;
      pPin->QueryDirection(&PinDirThis);
      if (bFound = (PinDir == PinDirThis))
        break;
      pPin->Release();
    }
  pEnum->Release();
  return (bFound ? pPin : 0);
}
void MyFreeMediaType(AM_MEDIA_TYPE& mt)
{
    if (mt.cbFormat != 0)
    {
        CoTaskMemFree((PVOID)mt.pbFormat);
        mt.cbFormat = 0;
        mt.pbFormat = NULL;
    }
    if (mt.pUnk != NULL)
    {
        mt.pUnk->Release();
        mt.pUnk = NULL;
    }
}
void MyDeleteMediaType(AM_MEDIA_TYPE *pmt)
{
    if (pmt != NULL)
    {
		MyFreeMediaType(*pmt);
        CoTaskMemFree(pmt);
    }
}

HRESULT SetImageSize()
{
	AM_MEDIA_TYPE mt;	
	if ( S_OK != pSGrab->GetConnectedMediaType(&mt) ) {return FALSE;}    
    VIDEOINFOHEADER * vih = (VIDEOINFOHEADER*) mt.pbFormat;
	m_Width  = vih->bmiHeader.biWidth;
	m_Height = vih->bmiHeader.biHeight;
	m_Size   = m_Width * m_Height * 3;
    MyFreeMediaType(mt);
	return S_OK;
}

HRESULT SetImageSize2(IBaseFilter *pSrc, int frameWidth, int frameHeight)
{
	HRESULT hr = S_FALSE;
	IAMStreamConfig *pAMStreamConfig;
	hr = pBuilder->FindInterface(	&PIN_CATEGORY_CAPTURE,
									&MEDIATYPE_Video,
									pSrc,
									IID_IAMStreamConfig,
									(void **)&pAMStreamConfig);
	if(SUCCEEDED(hr))
	{
		AM_MEDIA_TYPE* pMediaType;
		pAMStreamConfig->GetFormat( &pMediaType );
		VIDEOINFOHEADER* pVideoInfoHeader = (VIDEOINFOHEADER*)pMediaType->pbFormat;
		pVideoInfoHeader->bmiHeader.biWidth		= frameWidth;
		pVideoInfoHeader->bmiHeader.biHeight	= frameHeight;
		pAMStreamConfig->SetFormat( pMediaType );
		MyDeleteMediaType( pMediaType );
		int iCount=0, iSize=0;
		hr = pAMStreamConfig->GetNumberOfCapabilities(&iCount, &iSize);
		if(sizeof(VIDEO_STREAM_CONFIG_CAPS) == iSize)
		{
			for(int iFormat=0; iFormat<iCount; iFormat++)
			{
				VIDEO_STREAM_CONFIG_CAPS scc;
				AM_MEDIA_TYPE *pmtConfig;
				hr = pAMStreamConfig->GetStreamCaps(iFormat, &pmtConfig, (BYTE*)&scc);
				VIDEOINFOHEADER *pVih2;
				if(SUCCEEDED(hr))
				{
					if((pmtConfig->majortype == MEDIATYPE_Video)
						&& (pmtConfig->subtype == MEDIASUBTYPE_RGB24)
						&& (pmtConfig->formattype == FORMAT_VideoInfo)
						&& (pmtConfig->cbFormat >= sizeof(VIDEOINFOHEADER))
						&& (pmtConfig->pbFormat != NULL))
					{
						pVih2 = (VIDEOINFOHEADER*)pmtConfig->pbFormat;
						if ((frameHeight == pVih2->bmiHeader.biHeight) && (frameWidth == pVih2->bmiHeader.biWidth)){
							iFormat = iCount + 2;
						}
						pVih2->bmiHeader.biHeight    = frameHeight;
						pVih2->bmiHeader.biWidth     = frameWidth;
						pVih2->bmiHeader.biSizeImage = frameHeight * frameWidth * 3;
						pmtConfig->pbFormat = (BYTE*)pVih2;
						hr = pAMStreamConfig->SetFormat(pmtConfig);
						if(FAILED(hr)) {
							printf("pAMStreamConfig->SetFormat ERROR\n"); 
						}
					}
				}
			}
			
		}
		pAMStreamConfig->Release();
	}
	return S_OK;
}

int CameraPropaty( void )
{
	IEnumFilters *pEnum;
	IBaseFilter *pFilter = NULL;
	HRESULT hr;
	pGraph->EnumFilters(&pEnum);
	while(pEnum->Next(1, &pFilter, NULL) == S_OK)
	{
		ISpecifyPropertyPages *pSpecify;
		hr = pFilter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pSpecify);
		if (SUCCEEDED(hr)) {
		FILTER_INFO FilterInfo;
		pFilter->QueryFilterInfo(&FilterInfo);
		CAUUID caGUID;
		pSpecify->GetPages(&caGUID);
		pSpecify->Release();
		OleCreatePropertyFrame(		NULL,
									0,
									0,
									FilterInfo.achName,
									1,
									(IUnknown **)&pFilter,
									caGUID.cElems,
									caGUID.pElems,
									0,
									0,
									NULL);
			CoTaskMemFree(caGUID.pElems);
			FilterInfo.pGraph->Release();
		}
		pFilter->Release();
	}
	pEnum->Release();
	return 0;
}

int FuncDshowMainStart( int frameWidth, int frameHeight, int frameDepth, int propertySwitch)
{
	m_MySampleGrabberCB = new CMySampleGrabberCB(	m_iCameraNumber,
													frameWidth,
													frameHeight,
													frameDepth);
	HRESULT hRes = S_OK;
	CoInitialize(NULL);
	hRes = CoCreateInstance( CLSID_FilterGraph,
						NULL,
						CLSCTX_INPROC,
						IID_IGraphBuilder,
						(void **)&pGraph);
	if (S_OK != hRes) {
		printf("CoCreateInstance-1 ERROR\n");
		return 0;
	}
	ICreateDevEnum *pDevEnum = NULL;
	hRes = CoCreateInstance(	CLSID_SystemDeviceEnum,
						NULL,
						CLSCTX_INPROC,
						IID_ICreateDevEnum,
						(void **)&pDevEnum);
	if (S_OK != hRes) {
		printf("CoCreateInstance-2 ERROR\n");
		return 0;
	}
	IEnumMoniker *pClassEnum = NULL;
	hRes = pDevEnum->CreateClassEnumerator(	CLSID_VideoInputDeviceCategory,
										&pClassEnum,
										0);
	if (S_OK != hRes) {
		printf("CreateClassEnumerator ERROR\n");
		return 0;
	}
	ULONG cFetched;
	IMoniker *pMoniker = NULL;
	hRes = pClassEnum->Next(1, &pMoniker, &cFetched);
	if (S_OK != hRes) {
		printf("pClassEnum->Next ERROR\n");
		return 0;
	}
	pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void **)&pSrc);
	pMoniker->Release();
	pClassEnum->Release();
	pDevEnum->Release();
	pGraph->AddFilter(pSrc, L"Video Capture");
	hRes = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC,
	  IID_ICaptureGraphBuilder2, (void **)&pBuilder);
	if (S_OK != hRes) {
		printf("CoCreateInstance-3 ERROR\n");
		return 0;
	}
	pBuilder->SetFiltergraph(pGraph);
	if(propertySwitch == 0){
		CameraPropaty();
	}
	SetImageSize2(pSrc, frameWidth, frameHeight);
	hRes = CoCreateInstance(CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (LPVOID *)&pF);
	if (S_OK != hRes) {
		printf("CoCreateInstance-4 ERROR\n");
		return 0;
	}
	pF->QueryInterface(IID_ISampleGrabber, (void **)&pSGrab);
	AM_MEDIA_TYPE mt;
	ZeroMemory(&mt, sizeof(AM_MEDIA_TYPE));
	mt.majortype = MEDIATYPE_Video;
	mt.subtype = MEDIASUBTYPE_RGB24;     
	mt.formattype = FORMAT_VideoInfo;
	if ( S_OK != pSGrab->SetMediaType(&mt) )
	{
		printf("SetMediaType ERROR!!!\n"); 
		MyFreeMediaType(mt);
	}
	pGraph->AddFilter(pF, L"Grabber");
	IPin *pSrcOut   = GetPin(pSrc, PINDIR_OUTPUT);
	IPin *pSGrabIN  = GetPin(pF,   PINDIR_INPUT);
	IPin *pSGrabOut = GetPin(pF,   PINDIR_OUTPUT);
	pGraph->Connect(pSrcOut, pSGrabIN);
	pGraph->Render(pSGrabOut);
	SetImageSize();
	m_CamImage = new BYTE[m_Size]; 
	pSGrab->SetBufferSamples(TRUE);
	pSGrab->SetOneShot(FALSE);
	m_MySampleGrabberCB->SetImage(m_CamImage, m_Size);
	pSGrab->SetCallback(m_MySampleGrabberCB, 1);
	pBuilder->RenderStream( &PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, pSrc, NULL, NULL );
	pGraph->QueryInterface(IID_IMediaControl, (void **)&pMediaControl);
	pMediaControl->Run();
	return 0;
}

int FuncDshowMainEnd( void )
{
	if (NULL != pSrc)
		pSrc->Release();
	if (NULL != pMediaControl)
		pMediaControl->Release();
	if (NULL != pBuilder)
		pBuilder->Release();
	if (NULL != pGraph)
		pGraph->Release();
	CoUninitialize();
	pSrc = NULL;
	pMediaControl = NULL;
	pBuilder = NULL;
	pGraph = NULL;
	delete m_MySampleGrabberCB;
	return 0;
}
