#include "InUSBCamera.h"
#include "MySampleGrabberCB.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

RTC::CorbaConsumer<TimeServerInterface> m_eTimeServerInterface;

CMySampleGrabberCB::CMySampleGrabberCB(int CameraNum,int frameWidth, int frameHeight, int frameDepth)
{
	m_Buffer = NULL;
	m_iCameraNumber=CameraNum;
	m_iframeWidth=frameWidth;
	m_iframeHeigh=frameHeight;
	m_iframeDepth=frameDepth;

	record_ring_index = 0;
	record_readok_index = 0;
}

CMySampleGrabberCB::~CMySampleGrabberCB()
{
	record_index=0;
	record_count=0;
}

void CMySampleGrabberCB::SetImage(unsigned char *pBuffer,int nBufferSize)
{
	m_Buffer=pBuffer;
}

void CMySampleGrabberCB::GetNowTime( long *hour, long *min, long *sec, long *msec )
{
	SERVER_TM stm;
	bool ret = m_eTimeServerInterface->svr_getlocaltime(stm);
#ifdef _TEST_
	if (true == ret)
	{
		*hour = stm.tm_hour;
		*min  = stm.tm_min;
		*sec  = stm.tm_sec;
		*msec = stm.tm_msec;

		std::cout << "TRUE"  << std::endl;
		std::cout << "hour         [ " << stm.tm_hour << " ]" << std::endl;
		std::cout << "minutes      [ " << stm.tm_min  << " ]" << std::endl;
		std::cout << "seconds      [ " << stm.tm_sec  << " ]" << std::endl;
		std::cout << "milliseconds [ " << stm.tm_msec << " ]" << std::endl;
	} else {
		*hour = 0;
		*min  = 0;
		*sec  = 0;
		*msec = 0;
		std::cout << "FALSE" << std::endl;
	}
#endif
}


